const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of dosageUnits by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} dosageUnits - The array of dosageUnits to format.
 * @returns {Promise<Object[]>} - The formatted array of dosageUnits.
 */
const formatWithModifier = async (dosageUnits) => {
    return Promise.all(
        dosageUnits.map(async (dosageUnit) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: dosageUnit.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...dosageUnit,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all dosageUnits with their parent dosageUnit title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.dosageUnitsId - The ids of the dosageUnits to retrieve.
 * @returns {Promise<Object>} - The response object with the dosageUnits and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let dosageUnits = []
        dosageUnits = await dbSAPPS.DosageUnit.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        dosageUnits = dosageUnits.map(dosageUnit => {
            return {
                ...dosageUnit.dataValues
            }
        });

        dosageUnits = await formatWithModifier(dosageUnits);

        return {
            dosageUnits,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get dosageUnit items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the dosageUnit items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the dosageUnit items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the dosageUnit items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DosageUnit.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active dosageUnit items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DosageUnit.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new dosageUnit item.
 * 
 * @param {Object} params - The new dosageUnit item data.
 * @param {string} params.name - The name of the dosageUnit item.
 * @param {string} params.title - The title of the dosageUnit item.
 * @param {number} [params.parent_id] - The ID of the parent dosageUnit item.
 * @param {string} [params.url] - The URL of the dosageUnit item.
 * @param {string} [params.icon] - The icon of the dosageUnit item.
 * @param {string} [params.type=link] - The type of the dosageUnit item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the dosageUnit item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the dosageUnit item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the dosageUnit item.
 * @param {number} [params.owner=1] - The ID of the user who created the dosageUnit item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the dosageUnit item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageUnit item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DosageUnit.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DosageUnit.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing dosageUnit item.
 * 
 * @param {number} id - The ID of the dosageUnit item to update.
 * @param {Object} params - The updated dosageUnit item data.
 * @param {string} [params.name] - The new name of the dosageUnit item.
 * @param {string} [params.title] - The new title of the dosageUnit item.
 * @param {number} [params.parent_id] - The new parent ID of the dosageUnit item.
 * @param {string} [params.url] - The new URL of the dosageUnit item.
 * @param {string} [params.icon] - The new icon of the dosageUnit item.
 * @param {string} [params.type] - The new type of the dosageUnit item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the dosageUnit item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the dosageUnit item.
 * @param {number} [params.modified] - The new last modification timestamp of the dosageUnit item.
 * @param {number} [params.owner] - The new ID of the user who created the dosageUnit item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the dosageUnit item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageUnit item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageUnit = await dbSAPPS.DosageUnit.findByPk(id);
        if (!dosageUnit) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DosageUnit.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dosageUnit.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a dosageUnit
 * @param {number} id - the id of the dosageUnit
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageUnit = await dbSAPPS.DosageUnit.findByPk(id);
        if (!dosageUnit) return { success: false, message: 'ID not found!' };

        // delete
        await dosageUnit.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
